import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class Polimerizacao_Etapas extends PApplet {

// OBJETOS

Adipico a; // mol\u00e9cula de \u00e1cido ad\u00edpico, com 4 carbonos e uma carboxila em cada extremidade
Agua h; // mol\u00e9cula de \u00e1gua que \u00e9 formada na uni\u00e3o dos mon\u00f4meros distintos
Diamina d; // mol\u00e9cula de hexametilenoamina, com 6 carbonos e um radical amino em cada extremidade
Polimero p; // por\u00e7\u00e3o de pol\u00edmero que conta com objetos Diamina e Adipico unidos no formato de uma cadeia

//FONTE

PFont f;

// VARI\u00c1VEIS GLOBAIS

float comprimento; // define a escala das mol\u00e9culas
float velocidade; // velocidade da anima\u00e7\u00e3o

// VARI\u00c1VEIS DE ANIMA\u00c7\u00c3O

int etapa; // define a etapa da anima\u00e7\u00e3o: em '0' a mol\u00e9cula de \u00e1gua ainda n\u00e3o se formou e os mon\u00f4meros se aproximam,  
           // em '1' a mol\u00e9cula de \u00e1gua se afasta e os mon\u00f4meros se unem,  e '2' o zoom out na cadeia polim\u00e9rica
           
boolean play; // determina se h\u00e1 movimento ou n\u00e3o na 1\u00aa parte da anima\u00e7\u00e3o 

// BOT\u00d5ES

Botao botao;
Botao pausa;

// CR\u00c9DITO

Credito credito;

// SETUP

public void setup(){
  
 size(600, 600);
 smooth();
 strokeWeight(3); // a linha grossa transmite um ar 'amig\u00e1vel' \u00e0 imagem das mol\u00e9culas
 rectMode(CORNERS);
 textAlign(CENTER);
 //textMode(CENTER);
 
 // defini\u00e7\u00e3o das vari\u00e1veis globais
 comprimento = 60;
 velocidade = 0.6f;
 
 // carregamos a fonte
 f = loadFont("CourierNewPS-BoldMT-28.vlw");
 textFont(f, 38);
 
 // inicializamos o bot\u00e3o que regula as etapas
 botao = new Botao(width/2 + 200, height/2 + 80, 80, 20, "PR\u00d3XIMO");
 botao.situacao = "SELECIONADO";
 botao.psituacao = "LIBERADO";
 
 //inicializamos o bot\u00e3o de pausa
 pausa = new Botao(botao.xpos - 100, botao.ypos, 20, 20, ">");
 
 // definimos o cr\u00e9dito
 credito = new Credito();
 
 // inicializa\u00e7\u00e3o
 a = new Adipico(width/2 - 3*comprimento/2 , height/2 - 50);
 d = new Diamina(width/2 + comprimento/2, a.ypos);
 h = new Agua(width/2 - comprimento/2, a.ypos);
 p = new Polimero(- comprimento, a.ypos);
 etapa = 0;
 play = false; 
 
 background(255); // ativamos 'background' dentro do SETUP pois vamos escrever o texto 
                  // apenas UMA vez
 
 //TEXTO
  fill(0);
  text("POLIMERIZA\u00c7\u00c3O:\nEtapas", width/2, height/11);
  textFont(f, 14);
    text("A polimeriza\u00e7\u00e3o por etapas ocorre pela intera\u00e7\u00e3o qu\u00edmica entre \n" +
         "os mon\u00f4meros que gera, como resultado, a uni\u00e3o entre os meros e a  \n" +
         "forma\u00e7\u00e3o de mol\u00e9culas pequenas que n\u00e3o fazem parte do pol\u00edmero \n" +
         "(estas esp\u00e9cies condensam).\n \n" +
         "Acima acompanhamos, inicialmente, um passo da forma\u00e7\u00e3o do nylon,\n" +
         "partindo do \u00e1cido ad\u00edpico (ac\u00eddo dicarbox\u00edlico com cadeia de quatro\n" +
         "carbonos) e da hexametilenodiamina (diamina com seis carbonos),\n" +
         "formando uma mol\u00e9cula de \u00e1gua como subproduto da rea\u00e7\u00e3o.\n\n" + 
         "Na etapa seguinte observamos uma por\u00e7\u00e3o da cadeia polim\u00e9rica.", width/2, 3*height/4); 
}

//DRAW

public void draw(){
  
  if(credito.botao.situacao != "LIBERADO"){
    background(255);
    fill(0);
    textFont(f, 38);
    text("POLIMERIZA\u00c7\u00c3O:\nEtapas", width/2, height/11);
    textFont(f, 14);
    text("A polimeriza\u00e7\u00e3o por etapas ocorre pela intera\u00e7\u00e3o qu\u00edmica entre \n" +
         "os mon\u00f4meros que gera, como resultado, a uni\u00e3o entre os meros e a  \n" +
         "forma\u00e7\u00e3o de mol\u00e9culas pequenas que n\u00e3o fazem parte do pol\u00edmero \n" +
         "(estas esp\u00e9cies condensam).\n \n" +
         "Acima acompanhamos, inicialmente, um passo da forma\u00e7\u00e3o do nylon,\n" +
         "partindo do \u00e1cido ad\u00edpico (ac\u00eddo dicarbox\u00edlico com cadeia de quatro\n" +
         "carbonos) e da hexametilenodiamina (diamina com seis carbonos),\n" +
         "formando uma mol\u00e9cula de \u00e1gua como subproduto da rea\u00e7\u00e3o.\n\n" + 
         "Na etapa seguinte observamos uma por\u00e7\u00e3o da cadeia polim\u00e9rica.", width/2, 3*height/4);
  }
  
  fill(255);
  noStroke();
  rectMode(CORNERS);
  rect(0, a.ypos - height/4 - 5, width, a.ypos + height/4 + 10); // para n\u00e3o apagar o texto e, mesmo assim, atualizarmos a anima\u00e7\u00e3o,
                                                             // ao inv\u00e9s de colorir toda a tela, definimos um ret\u00e2ngulo que ser\u00e1
                                                             // apagado e coberto a cada passo da anima\u00e7\u00e3o.
  roda(); // rodamos a anima\u00e7\u00e3o
  legenda(width/20, 3*height/5);
  botao.display();
  pausa.display();
  credito.display();
}

// fun\u00e7\u00e3o de anima\u00e7\u00e3o
public void roda(){
  
  if(etapa < 2){
    //desenhamos as mo\u00e9culas de \u00e1c. ad\u00edpico e da diamina
    d.display(); 
    a.display();
  
    if(play){
      // se a anima\u00e7\u00e3o estiver rodando, as mol\u00e9culas se preparam para a uni\u00e3o: 'abrem-se'
      a.abre(velocidade/24);
      d.abre(velocidade/24);
  
      // enquanto as mol\u00e9culas n\u00e3o estiverem perto o suficiente (a \u00e1gua ainda n\u00e3o se formou), a mol\u00e9cula de
      // \u00e1c. ad\u00edpico vai se aproximando da outra
      if(d.xpos - a.xpos > 3*comprimento/2 ){
      a.anda(velocidade, 0);
      }  
      else
        etapa = 1; //se a mol\u00e9cula de \u00e1gua est\u00e1 formada, define-se a etapa 1
  
    }
    
      if(etapa == 1){
        
        // enquanto os mon\u00f4meros ainda n\u00e3o est\u00e3o unidos, eles se aproximam
        if(d.xpos - a.xpos > comprimento/2 && play == true){
          a.anda(velocidade, 0);
          d.anda(- velocidade, 0);
        }
        
        // \u00e0 medida que a mol\u00e9cula de \u00e1gua vai se distanciando
       if(h.ypos < a.ypos + height/6){
        h.display(); // desenhamos a mol\u00e9cula de \u00e1gua
        if(play){
          h.anda(0, 3*velocidade/2); // ela anda para a parte inferior da tela
          h.gira(0.005f); // e gira sutilmente
        }
       }
      }
  }
  
  // na segunda etapa mostramos o pol\u00edmero montado e diminuimos progressivamente a escala,
  // dando a impress\u00e3o de que a c\u00e2mera se afasta da cadeia polim\u00e9rica
  if(etapa == 2){
    
    if(play)
      p.update(); // atualiza a escala do pol\u00edmero
    
    p.display(); // desenha o pol\u00edmero
    
    if(play){
      if(comprimento > 20){
      
        if(comprimento < 50 && comprimento > 30)
          strokeWeight(2);
      
        if(comprimento < 30)
          strokeWeight(1); 
      
        comprimento -= 0.1f; // diminui\u00e7\u00e3o da escala at\u00e9 comprimento atingir o valor 20
      }
    }
  }
}
 // escrevemos a legenda de cores, relacionando os \u00e1tomos
public void legenda(float x, float y){
  textAlign(LEFT);
  textFont(f, 12);
  rectMode(CENTER);
  pushMatrix();
  translate(x, y);
  fill(255);
  rect(70, 30, 140, 80);
  fill(0);
  noStroke();
  text("Legenda:", 0, 0);
  text("Carbono", 60, 15);
  fill(0xff91D6F7); //AZUL
  ellipse(50, 11, 10, 10);
  fill(0);
  text("Hidrog\u00eanio", 60, 30);
  fill(122);
  ellipse(50, 26, 10, 10);
  fill(0);
  text("Nitrog\u00eanio", 60, 45);
  fill(0xff08FF85);
  ellipse(50, 41, 10, 10);
  fill(0);
  text("Oxig\u00eanio", 60, 60);
  fill(0xffFC928F);
  ellipse(50, 56, 10, 10);
  popMatrix();
  textAlign(CENTER);
  rectMode(CORNERS);
}

// ao apertar o mouse
public void mousePressed(){
  
  if(pausa.situacao == "SELECIONADO" || etapa == 2)
    botao.mousePressed();
    
  pausa.mousePressed();
  // no passo da polimeriza\u00e7\u00e3o o clique pode 'pausar' a anima\u00e7\u00e3o
  //if(etapa < 2){
  if(botao.situacao == "PRESSIONADO"){ 
   /* 
    if(pausa.situacao == "LIBERADO")
      play = true;
    else if(pausa.situacao == "SELECIONADO")
      play = false;
    */
    // na apresenta\u00e7\u00e3o do pol\u00edmero, o clique reinicia a anima\u00e7\u00e3o  
    if(etapa == 2){
     strokeWeight(3);    
     comprimento = 60;
     etapa = 0;
     a = new Adipico(width/2 - 3*comprimento/2 , height/2 - 20);
     d = new Diamina(width/2 + comprimento/2, a.ypos);
     h = new Agua(width/2 - comprimento/2, a.ypos);
     p = new Polimero(- comprimento, a.ypos);
     play = false;
     pausa.psituacao = "SELECIONADO";
     pausa.situacao = "LIBERADO";
     pausa.texto = ">";
     botao.texto = "PR\u00d3XIMO";
   }
   
    // durante a etapa '1', o clique muda para a etapa da anima\u00e7\u00e3o
    if(etapa == 1){
      etapa ++;
      botao.texto = "IN\u00cdCIO";
    }
     
      
  }
 
   
  
  
  credito.botao.mousePressed();
}

public void mouseReleased(){
  
 /* if(botao.situacao == "PRESSIONADO")
    botao.libera();*/
  
  boolean pressionado = false;
  
  if(pausa.situacao == "PRESSIONADO")
    pressionado = true;
  
  pausa.mouseReleased();
  
  if(pausa.situacao == "LIBERADO" && pressionado){
    play = false;
    pausa.texto = ">";
  }
  else if(pausa.situacao == "SELECIONADO" && pressionado){
    play = true;
    pausa.texto = "||";
  }
  
  if(pausa.situacao == "SELECIONADO")
    botao.libera();
    
  credito.botao.mouseReleased();
  
}

class Adipico{
  
  // propriedades da classe
  float xpos, ypos; // posi\u00e7\u00e3o do \u00e1tomo de carbono que fica mais \u00e0 direita
  float offset = comprimento/30; // define a separa\u00e7\u00e3o entre as liga\u00e7\u00f5es da dupla-liga\u00e7\u00e3o
  
  // v\u00e1ri\u00e1veis de anima\u00e7\u00e3o
  
  float w = 0; // define a abertura das liga\u00e7\u00f5es no \u00e1tomo de carbono \u00e0 DIREITA (se seu valor \u00e9 '1',
               // n\u00e3o desenha-se um dos \u00e1tomos de oxig\u00eanio e um dos de hidrog\u00eanio)
               
  float u = 0; // define a abertura das liga\u00e7\u00f5es no \u00e1tomo de carbono \u00e0 ESQUERDA(se seu valor \u00e9 '1', 
               // n\u00e3o desenhamos um dos \u00e1tomos de oxig\u00eanio e um dos de hidrog\u00eanio)
  
  // CONSTRUTORA
  Adipico(float x, float y){
    xpos = x;
    ypos = y;
  }
  
  // fun\u00e7\u00e3o que desenha a mol\u00e9cula de mon\u00f4mero
  public void display(){
    
    offset = comprimento/30; // atualizamos o valor do offset, caso 'comprimento' tenha sido mudado
    
    pushMatrix();
    translate(xpos, ypos); // origem: posi\u00e7\u00e3o do \u00e1tomo de carbono mais \u00e0 direita
    stroke(0);
    line(0, 0, -comprimento/4, 0);
    // desenhamos os \u00e1tomos ligados ao carbono mais \u00e0 esquerda
    pushMatrix();
    rotate( - PI/3 - w*PI/6); // giramos para desenhar a liga\u00e7\u00e3o dupla
    line(0, offset, comprimento/2, offset);        // liga\u00e7\u00e3o
    line(0, - offset, comprimento/2, - offset);    //  dupla
    noStroke();
    fill(0xffFC928F); // ROSA
    ellipse(comprimento/2, 0, 1.1f*comprimento/5, 1.1f*comprimento/5); // desenha o \u00e1tomo de oxig\u00eanio
    popMatrix();
    pushMatrix();
    rotate(PI/3 - w*PI/3); // giramos para desenhar o outro \u00e1tomo de oxig\u00eanio, ligado a um hidrog\u00eanio
    stroke(0);
    line(0, 0, comprimento/4, 0);
    
    if(etapa == 0){ // s\u00f3 desenhamos estes \u00e1tomos se a etapa for 0 
      pushMatrix();
      translate(comprimento/2, 0); // origem: \u00e1tomo de oxig\u00eanio ligado simplesmente ao carbono mais \u00e0 direita
      rotate(w*PI);
      line(0, 0, -comprimento/4, 0);
      rotate(- PI/3);
      line(0, 0, comprimento/2, 0);
      noStroke(); // para n\u00e3o haver contorno
      fill(122); // CINZA
      ellipse(comprimento/2, 0, comprimento/5, comprimento/5); // desenhamos o \u00e1tomo de hidrog\u00eanio
      fill(0xffFC928F); // ROSA
      ellipse(0, 0, 1.1f*comprimento/5, 1.1f*comprimento/5); // desenhamos o segundo \u00e1tomo de oxig\u00eanio
      popMatrix(); // voltamos com a origem no \u00e1tomo de carbono mais \u00e0 direita
    }
    
    noStroke();
    fill(0xff91D6F7); // AZUL
    ellipse(0, 0, 1.3f*comprimento/5, 1.3f*comprimento/5); // desenhamos o \u00e1tomo de carbono mais \u00e0 direita
    popMatrix();
    
    // para desenhar os carbonos internos \u00e0 mol\u00e9cula, com seus hidrog\u00eanios ligados:    
    for(int i = 1; i <= 4; i++){
      pushMatrix();
      translate(- i*comprimento/2, 0); // mudamos a origem para a posi\u00e7\u00e3o do carbono a ser desenhado
      stroke(0);
      line(0, 0, 0, 5*comprimento/12);
      line(0, 0, 0, - 5*comprimento/12);
      line(0, 0, comprimento/4, 0);
      line(0, 0, - comprimento/4, 0);
      noStroke();
      fill(122); // CINZA
      ellipse(0, 5*comprimento/12, comprimento/5, comprimento/5);         // desenhamos os \u00e1tomos
      ellipse(0, - 5*comprimento/12, comprimento/5, comprimento/5);       // de hidrog\u00eanio
      fill(0xff91D6F7); // AZUL
      ellipse(0, 0, 1.3f*(comprimento/5), 1.3f*(comprimento/5)); // desenhamos o \u00e1tomo de carbono
      popMatrix();
    }
    
    // ent\u00e3o fazemos o mesmo que fizemos com a extremidade esquerda na outra extremidade
    // espelhando as liga\u00e7\u00f5es para adaptarmos o desenho \u00e0 simetria
    pushMatrix();
    translate(- 5*comprimento/2, 0); // origem: \u00e1tomo de carbono mais \u00e0 esquerda
    stroke(0);
    line(0, 0, comprimento/4, 0);
    pushMatrix();
    rotate( - 2*PI/3 + u*PI/6); // giramos para desenhar a liga\u00e7\u00e3o dupla
    line(0, offset, comprimento/2, offset);                // liga\u00e7\u00e3o
    line(0, - offset, comprimento/2, - offset);            // dupla
    noStroke();
    fill(0xffFC928F); // ROSA
    ellipse(comprimento/2, 0, 1.1f*comprimento/5, 1.1f*comprimento/5); // desenhamos o \u00e1tomo de oxig\u00eanio com liga\u00e7\u00e3o dupla
    popMatrix();
    pushMatrix();
    rotate(2*PI/3 + u*PI/3); // giramos para desenhar a liga\u00e7\u00e3o simples com o outro oxig\u00eanio
    stroke(0);
    line(0, 0, comprimento/4, 0);
    
    // dependendo do valor assumido por 'u', mostramos ou n\u00e3o o \u00e1tomo de oxig\u00eanio ligado ao hidrog\u00eanio (e ao carbono \u00e0 esquerda)
    if(u != 1){ 
      pushMatrix();
      translate(comprimento/2, 0);
      line(0, 0, -comprimento/4, 0);
      rotate(PI/3); // giramos para desenhar o hidrog\u00eanio ligado
      line(0, 0, 5*comprimento/12, 0);
      noStroke();
      fill(122); // CINZA
      ellipse(5*comprimento/12, 0, comprimento/5, comprimento/5); // desenhamos o hidrog\u00eanio
      fill(0xffFC928F); // VERMELHO
      ellipse(0, 0, 1.1f*comprimento/5, 1.1f*comprimento/5); // desenhamos o oxig\u00eanio
      popMatrix();
    }    
    
    noStroke();
    fill(0xff91D6F7); // AZUL
    ellipse(0, 0, 1.3f*comprimento/5, 1.3f*comprimento/5); // desenhamos o \u00faltimo carbono
    popMatrix();
    popMatrix();
    popMatrix();
  }
  
  // fun\u00e7\u00e3o que faz a 'abertura' das liga\u00e7\u00f5es do carbono mais \u00e0 direta, ao mudar o valor de 'w'
  public void abre(float v){
    if(w < 1)
      w += v;
    else
      w = 1;
  }
  
  // fun\u00e7\u00e3o que faz a mol\u00e9cula se mover no plano
  public void anda(float vx, float vy){
    xpos += vx;
    ypos += vy;
  }

  // define uma nova posi\u00e7\u00e3o
  public void setPosition(float x, float y){
    xpos = x;
    ypos = y;
  }
}
class Agua{
  
  // propriedades da classe
 float xpos, ypos; // coordenadas da posi\u00e7\u00e3o do \u00e1tomo de oxig\u00eanio
 float angle = 0; // \u00e2ngulo de giro da mol\u00e9cula em rela\u00e7\u00e3o ao eixo 'z'
 
 // CONSTRUTORA
 Agua(float x, float y){
   xpos = x;
   ypos = y;
 }
 
 // fun\u00e7\u00e3o que desenha a mol\u00e9cula de \u00e1gua
 public void display(){
   pushMatrix();
   translate(xpos, ypos); // origem: \u00e1tomo de oxig\u00eanio 
   rotate(angle); // gira o sistema de coordenadas de 'angle'
   pushMatrix();
   rotate(2*PI/3);
   stroke(0);
   line(0, 0, comprimento/2, 0);
   noStroke();
   fill(122); // CINZA
   ellipse(comprimento/2, 0, comprimento/5, comprimento/5); // desenhamos um \u00e1tomo de hidrog\u00eanio
   popMatrix();
   stroke(0);
   line(0, 0, comprimento/2, 0);
   noStroke();
   ellipse(comprimento/2, 0, comprimento/5, comprimento/5); // desenhamos o outro \u00e1tomo de hidrog\u00eanio
   fill(0xffFC928F); // ROSA
   ellipse(0, 0, 1.1f*comprimento/5, 1.1f*comprimento/5); // desenhamos o \u00e1tomo de oxig\u00eanio
   popMatrix();
 }
 
 // fun\u00e7\u00e3o que faz a mol\u00e9cula se mover no plano
 public void anda(float vx, float vy){
   xpos += vx;
   ypos += vy;
 }
 
 // fun\u00e7\u00e3o que faz a mol\u00e9cula girar nu eixo 'z'
 public void gira(float w){
   angle += w;
 }

 // define uma nova posi\u00e7\u00e3o
 public void setPosition(float x, float y){
   xpos = x;
   ypos = y;
 }
}
   
   
// BOT\u00c3O///

class Botao{
  float xpos, ypos; // coordenadas do centro do bot\u00e3o
  
  String texto, // guarda o texto a ser impresso no bot\u00e3o
  
         situacao, // guarda a situa\u00e7\u00e3o em que se encontra o bot\u00e3o, podendo estar "LIBERADO", "PRESSIONADO" ou "SELECIONADO"
  
         psituacao;  // guarda a situa\u00e7\u00e3o 'est\u00e1vel' que o bot\u00e3o assumira antes de ser pressionado pela \u00faltima vez
                     // (pode guardar "LIBERADO" ou "SELECIONADO") 
  
  float comprimento; // comprimento de refer\u00eancia do bot\u00e3o (ret\u00e2ngulo interno)
  
  float altura; // altura de refer\u00eancia do bot\u00e3o (ret\u00e2ngulo interno)
  
  
  //CONSTRUTORA SIMPLES//
  Botao(float _xpos, float _ypos, String _texto){
    xpos = _xpos;
    ypos = _ypos;
    texto = _texto;
    situacao = "LIBERADO";        // a priore, o bot\u00e3o \u00e9 iniciado como se n\u00e3o estivesse ativado 
    psituacao = "SELECIONADO";    // caso queiramos que ele apresente-se 'selecionado' logo de
                                  // in\u00edcio, trocamos estas vari\u00e1veis apos a chamada da fun\u00e7\u00e3o
                                  // construtora (tratam-se de par\u00e2metros PUBLICOS)
                                  
    //comprimento = 12*texto.length();
    
    // dimens\u00f5es-padr\u00e3o
    altura = 20;    
    comprimento = 92;
  }

  //CONSTUTRUTORA EXTENDIDA (entramos com os valores de 'comprimento' e 'altura' do ret\u00e2ngulo interno do bot\u00e3o)
  Botao(float _xpos, float _ypos, float _comprimento, float _altura, String _texto){
    xpos = _xpos;
    ypos = _ypos;
    comprimento = _comprimento;
    altura = _altura;
    texto = _texto;
    situacao = "LIBERADO";        // da mesma forma que na outra construtora 
    psituacao = "SELECIONADO"; 
    }

  //desenhamos o bot\u00e3o
  public void display(){
    rectMode(CENTER);
    noStroke();
    pushMatrix();
    translate(xpos, ypos); //origem: centro do bot\u00e3o
   
    // as cores dos ret\u00e2ngulos dependem da situa\u00e7\u00e3o em que o bot\u00e3o se encontra
    
    //ret\u00e2ngulo externo
    if(situacao == "LIBERADO")
      fill(180);
    else if(situacao == "PRESSIONADO")
      fill(200);
    else if(situacao == "SELECIONADO")
      fill(220);
    
    rect(0, 0, comprimento + 20, altura + 20); // desenhamos o ret\u00e2ngulo
    
    //ret\u00e2ngulo intermedi\u00e1rio
    if(situacao == "LIBERADO")
      fill(200);
    else if(situacao == "PRESSIONADO")
      fill(220);
    else if(situacao == "SELECIONADO")
      fill(180);
    
    rect(0, 0, comprimento + 10, altura + 10); // desenhamos o ret\u00e2ngulo
    
    //ret\u00e2ngulo interno
    if(situacao == "LIBERADO")
      fill(220);
    else if(situacao == "PRESSIONADO")
      fill(180);
    else if(situacao == "SELECIONADO")
      fill(200);
    
    rect(0, 0, comprimento , altura); // desenhamos o ret\u00e2ngulo
    
    //a cor do texto tamb\u00e9m depende da situa\u00e7\u00e3o do bot\u00e3o
    if(situacao == "PRESSIONADO")
      fill(255);
    else
      fill(0);
    
    text(texto, 0, 4); // escrevemos o texto
    
    popMatrix();  
  }
  
  //fun\u00e7\u00e3o chamada pelo clique do bot\u00e3o (embora o nome seja o mesmo da fun\u00e7\u00e3o da biblioteca interna
  //                                     do Processing, esta fun\u00e7\u00e3o n\u00e3o \u00e9 chamada automaticamente
  //                                     pelo clique do mouse. Portanto devemos cham\u00e1-la dentro da
  //                                     fun\u00e7\u00e3o mousePressed do Processing)
  public void mousePressed(){
    float dx = mouseX - xpos;
    float dy = mouseY - ypos;
    
    //se, no momento do clique do mouse, este estiver sobre o bot\u00e3o, o mesmo assume a situa\u00e7\u00e3o "PRESSIONADO"
    if(abs(dx) < (comprimento)/2 && abs(dy) < (altura)/2)
      situacao = "PRESSIONADO";    
  }
  
  //fun\u00e7\u00e3o chamada pela libera\u00e7\u00e3o do bot\u00e3o do mouse (vale o mesmo dito para a fun\u00e7\u00e3o mousePressed)
  public void mouseReleased(){
    
    if(situacao == "PRESSIONADO" && psituacao == "LIBERADO"){
      situacao = psituacao;
      psituacao = "SELECIONADO";
    }
    
    if(situacao == "PRESSIONADO" && psituacao == "SELECIONADO"){
      situacao = psituacao;
      psituacao = "LIBERADO";
    }
    
    //se o bot\u00e3o foi pressionado, ap\u00f3s a libera\u00e7\u00e3o do mouse o primeiro assume a situa\u00e7\u00e3o "SELECIONADO"
   /* if(situacao == "PRESSIONADO"){
      situacao = "SELECIONADO";
      psituacao = "LIBERADO";
    }*/
      
  }
  
  //fun\u00e7\u00e3o que libera o bot\u00e3o
  public void libera(){
    psituacao = "SELECIONADO";
    situacao = "LIBERADO";
  }

}
class Credito{
  
  Botao botao;
  
  PFont f;
  
  boolean mais;
  
  Credito(){
    botao = new Botao(width - 40, 20, 45, 20, "Cr\u00e9ditos");
    f = loadFont("ArialUnicodeMS-11.vlw");
    mais = false;
  }

 public void display(){     
   textFont(f, 11);
   botao.display();
   rectMode(CORNERS);
   if( botao.situacao == "SELECIONADO" ){
     fill(240, 200);
     textAlign(LEFT);     
     if(mais){
       //rect(width/2, height/2, 400, 400);
       rect(width/2 - 200, height/2 - 200, width/2 + 200, height/2 + 200);
       fill(0);
       text( "\t\t                                                                            CR\u00c9DITOS" +
           "\n\nDesenvolvimento: Gustavo S. Jacomini (2\u00baano, Engenharia Civil-Escola Polit\u00e9cnica)" +
           "\n" + 
           "\n\nOrienta\u00e7\u00e3o: Ivette Frida Cymbaum Oppenheim (Departamento de Engenharia" + 
           "\n                                                                        Metal\u00fargica e de Materiais - Escola Polit\u00e9cnica)" +
           "\n\ncriado em:" + 
//           " Processing" + 
           "\n\n\nO meio:    'Processing' \u00e9 uma linguagem de programa\u00e7\u00e3o e ambiente de" +  
           "\n                      desenvolvimento com foco principal nas artes visuais, apro-" +
           "\n                      veitando-se da plataforma Java e de uma comunidade virtual" + 
           "\n                      intensamente atuante atrav\u00e9s do compartilhamento de c\u00f3di-" + 
           "\n                      gos e bibliotecas atrav\u00e9s da internet." + 
           "\n\n                      Surgiu como iniciativa de Casey Reas e Ben Fry, pesquisa-" +
           "\n                      dores do Instituto de Tecnologia de Massachussets (MIT)," +
           "\n                      sendo, desde sua cria\u00e7\u00e3o,disponibilizado gratuitamente co-" +
           "\n                      mo software livre,acess\u00edvel a qualquer interessado a partir" + 
           "\n                      do download no site 'processing.org',onde podem ser en-" +
           "\n                      contradas informa\u00e7\u00f5es adicionais sobre 'Processing'." +    
           "\n\n\nApoio:     'Anima\u00e7\u00f5es para Disciplinas Introdut\u00f3rias de Ci\u00eancia e Engenharia dos"  + 
           "\n                      Materiais' \u00e9 integrante do 'Programa Ensinar com Pesquisa', iniciativa"  +
           "\n                      da Pr\u00f3-Reitoria de Gradua\u00e7\u00e3o da Universidade de S\u00e3o Paulo,  \u00e0 qual"  +
           "\n                      expressamos nossos agradecimentos (Projeto 598 - Ano 2009).",width/2 - 190, height/2 - 170);
     }
     
     else if(mais == false){
       rect(width/2 - 200, height/2 - 200, width/2 + 200, height/2 + 30);
       fill(0);
       text( "\t\t                                                                            CR\u00c9DITOS" +
           "\n\nDesenvolvimento: Gustavo S. Jacomini (2\u00baano, Engenharia Civil-Escola Polit\u00e9cnica)" +
           "\n" + 
           "\n\nOrienta\u00e7\u00e3o: Ivette Frida Cymbaum Oppenheim (Departamento de Engenharia" + 
           "\n                                                                        Metal\u00fargica e de Materiais - Escola Polit\u00e9cnica)" +
           "\n\ncriado em:" +    
           "\n\n\nApoio:     'Anima\u00e7\u00f5es para Disciplinas Introdut\u00f3rias de Ci\u00eancia e Engenharia dos"  + 
           "\n                      Materiais' \u00e9 integrante do 'Programa Ensinar com Pesquisa', iniciativa"  +
           "\n                      da Pr\u00f3-Reitoria de Gradua\u00e7\u00e3o da Universidade de S\u00e3o Paulo,  \u00e0 qual"  +
           "\n                      expressamos nossos agradecimentos (Projeto 598 - Ano 2009).",width/2 - 190, height/2 - 170);
       
     }
     textAlign(CENTER);
     
     if(!mais)
       fill(0, 0, 150);
     else if(mais)
       fill(150);
     
     if(abs(mouseX - (width/2 - 86)) < 30 && abs(mouseY - (height/2 - 68)) < 10){
       if(mousePressed)
         fill(255);
       else{
         if(!mais)
           fill(100, 100, 255);
         else if(mais)
           fill(200);
       }
     }
     
     text("Processing", width/2 - 86, height/2 - 68);
    
          
   }
   rectMode(CENTER);
 }
 
 class Botao{
  float xpos, ypos; // coordenadas do centro do bot\u00e3o
  
  String texto, // guarda o texto a ser impresso no bot\u00e3o
  
         situacao, // guarda a situa\u00e7\u00e3o em que se encontra o bot\u00e3o, podendo estar "LIBERADO", "PRESSIONADO" ou "SELECIONADO"
  
         psituacao;  // guarda a situa\u00e7\u00e3o 'est\u00e1vel' que o bot\u00e3o assumira antes de ser pressionado pela \u00faltima vez
                     // (pode guardar "LIBERADO" ou "SELECIONADO") 
  
  float comprimento; // comprimento de refer\u00eancia do bot\u00e3o (ret\u00e2ngulo interno)
  
  float altura; // altura de refer\u00eancia do bot\u00e3o (ret\u00e2ngulo interno)
  
  
  //CONSTRUTORA SIMPLES//
  Botao(float _xpos, float _ypos, String _texto){
    xpos = _xpos;
    ypos = _ypos;
    texto = _texto;
    situacao = "LIBERADO";        // a priore, o bot\u00e3o \u00e9 iniciado como se n\u00e3o estivesse ativado 
    psituacao = "SELECIONADO";    // caso queiramos que ele apresente-se 'selecionado' logo de
                                  // in\u00edcio, trocamos estas vari\u00e1veis apos a chamada da fun\u00e7\u00e3o
                                  // construtora (tratam-se de par\u00e2metros PUBLICOS)
                                  
    //comprimento = 12*texto.length();
    
    // dimens\u00f5es-padr\u00e3o
    altura = 20;    
    comprimento = 92;
  }

  //CONSTUTRUTORA EXTENDIDA (entramos com os valores de 'comprimento' e 'altura' do ret\u00e2ngulo interno do bot\u00e3o)
  Botao(float _xpos, float _ypos, float _comprimento, float _altura, String _texto){
    xpos = _xpos;
    ypos = _ypos;
    comprimento = _comprimento;
    altura = _altura;
    texto = _texto;
    situacao = "LIBERADO";        // da mesma forma que na outra construtora 
    psituacao = "SELECIONADO"; 
    }

  //desenhamos o bot\u00e3o
  public void display(){
    noStroke();
    rectMode(CENTER);
    pushMatrix();
    translate(xpos, ypos); //origem: centro do bot\u00e3o
   
    // as cores dos ret\u00e2ngulos dependem da situa\u00e7\u00e3o em que o bot\u00e3o se encontra
    
   /* //ret\u00e2ngulo externo
    if(situacao == "LIBERADO")
      fill(255 - 180);
    else if(situacao == "PRESSIONADO")
      fill(255 - 200);
    else if(situacao == "SELECIONADO")
      fill(255 - 220);
    
    rect(0, 0, comprimento + 20, altura + 20); // desenhamos o ret\u00e2ngulo
    */
    //ret\u00e2ngulo intermedi\u00e1rio
    if(situacao == "LIBERADO")
      fill(200);
    else if(situacao == "PRESSIONADO")
      fill(220);
    else if(situacao == "SELECIONADO")
      fill(180);
    
    rect(0, 0, comprimento + 10, altura + 10); // desenhamos o ret\u00e2ngulo
    
    //ret\u00e2ngulo interno
    if(situacao == "LIBERADO")
      fill(220);
    else if(situacao == "PRESSIONADO")
      fill(180);
    else if(situacao == "SELECIONADO")
      fill(200);
    
    rect(0, 0, comprimento , altura); // desenhamos o ret\u00e2ngulo
    
    //a cor do texto tamb\u00e9m depende da situa\u00e7\u00e3o do bot\u00e3o
    if(situacao == "PRESSIONADO")
      fill(255);
    else
      fill(0);
    
    text(texto, 0, 4); // escrevemos o texto
    
    popMatrix();  
  }
  
  //fun\u00e7\u00e3o chamada pelo clique do bot\u00e3o (embora o nome seja o mesmo da fun\u00e7\u00e3o da biblioteca interna
  //                                     do Processing, esta fun\u00e7\u00e3o n\u00e3o \u00e9 chamada automaticamente
  //                                     pelo clique do mouse. Portanto devemos cham\u00e1-la dentro da
  //                                     fun\u00e7\u00e3o mousePressed do Processing)
  public void mousePressed(){
    float dx = mouseX - xpos;
    float dy = mouseY - ypos;
    
    //se, no momento do clique do mouse, este estiver sobre o bot\u00e3o, o mesmo assume a situa\u00e7\u00e3o "PRESSIONADO"
    if(abs(dx) < (comprimento)/2 && abs(dy) < (altura)/2)
      situacao = "PRESSIONADO";
    
    //gerenciamos a apresenta\u00e7\u00e3o de informa\u00e7\u00f5es adicionais pelo clique sobre a palavra 'Processing'
    if(abs(mouseX - (width/2 - 86)) < 30 && abs(mouseY - (height/2 - 68)) < 10)
      mais = !mais;    
  }
  
  //fun\u00e7\u00e3o chamada pela libera\u00e7\u00e3o do bot\u00e3o do mouse (vale o mesmo dito para a fun\u00e7\u00e3o mousePressed)
  public void mouseReleased(){
    
    /*if(situacao == "PRESSIONADO" && psituacao == "LIBERADO"){
      situacao = psituacao;
      psituacao = "SELECIONADO";
    }
    
    if(situacao == "PRESSIONADO" && psituacao == "SELECIONADO"){
      situacao = psituacao;
      psituacao = "LIBERADO";
    }*/
    
    //se o bot\u00e3o foi pressionado, ap\u00f3s a libera\u00e7\u00e3o do mouse o primeiro assume a situa\u00e7\u00e3o "SELECIONADO"
    if(situacao == "PRESSIONADO" && psituacao == "SELECIONADO"){
      situacao = "SELECIONADO";
      psituacao = "LIBERADO";
    }
    
    if(situacao == "PRESSIONADO" && psituacao == "LIBERADO"){
      situacao = "LIBERADO";
      psituacao = "SELECIONADO";
    }
    
    
       
  }
  
  //fun\u00e7\u00e3o que libera o bot\u00e3o
  public void libera(){
    psituacao = "SELECIONADO";
    situacao = "LIBERADO";
  }

}
}
 
class Diamina{
  
  // propriedades da classe
  float xpos, ypos; // posi\u00e7\u00e3o do \u00e1tomo de nitrog\u00eanio \u00e0 esquerda
  
  float w = 0; // define a abertura das liga\u00e7\u00f5es no \u00e1tomo de nitrog\u00eanio \u00e0 ESQUERDA (se seu valor \u00e9 '1',
               // n\u00e3o desenha-se um dos \u00e1tomos de hidrog\u00eanio)
               
  float u = 0; // define a abertura das liga\u00e7\u00f5es no \u00e1tomo de nitrog\u00eanio \u00e0 DIREITA (se seu valor \u00e9 '1', 
               // n\u00e3o desenhamos um dos \u00e1tomos de hidrog\u00eanio)
  
  // CONSTRUTORA
  Diamina(float x, float y){
    xpos = x;
    ypos = y;
  }
  
  // fun\u00e7\u00e3o que desenha a mol\u00e9cula de diamina
  public void display(){
    pushMatrix();
    translate(xpos, ypos); // origem: \u00e1tomo de nitrog\u00eanio mais \u00e0 esquerda
    stroke(0);
    line(0, 0, comprimento/4, 0);
    pushMatrix();
    rotate( 4*PI/3 + w*PI/6);
    line(0, 0, comprimento/2, 0);
    noStroke();
    fill(122); // CINZA
    ellipse(comprimento/2, 0, comprimento/5, comprimento/5); // desenhamos um \u00e1tomo de hidrog\u00eanio ligado ao de nitrog\u00eanio \u00e0 esquerda
    popMatrix();
    pushMatrix();
    rotate(2*PI/3 + w*PI/3);
    stroke(0);
    line(0, 0, comprimento/4, 0);
    
    if(etapa == 0){ // s\u00f3 desenhamos este \u00e1tomo se a etapa for 0
      pushMatrix();
      translate(comprimento/2, 0); // origem: segundo \u00e1tomo de hidrog\u00eanio ligado ao de nitrog\u00eanio mais \u00e0 esquerda
      rotate(w*PI);                              
      line(0, 0, -comprimento/4, 0);
      noStroke();
      fill(122); // CINZA
      ellipse(0, 0, comprimento/5, comprimento/5); // desenhamos o \u00e1tomo de hidrog\u00eanio
      popMatrix();
    }
    
    noStroke();    
    fill(0xff08FF85); // VERDE
    ellipse(0, 0, 1.3f*comprimento/5, 1.3f*comprimento/5); // desenhamos o \u00e1tomo de nitrog\u00eanio
    popMatrix();
    
    // para desenhar os carbonos internos \u00e0 mol\u00e9cula, com seus hidrog\u00eanios ligados:
    for(int i = 1; i <= 6; i++){
      pushMatrix();
      translate(i*comprimento/2, 0);
      stroke(0);
      line(0, 0, 0, 5*comprimento/12);
      line(0, 0, 0, - 5*comprimento/12);
      line(0, 0, comprimento/4, 0);
      line(0, 0, - comprimento/4, 0);
      noStroke();
      fill(122); // CINZA
      ellipse(0, 5*comprimento/12, comprimento/5, comprimento/5);      // \u00e1tomos de 
      ellipse(0, - 5*comprimento/12, comprimento/5, comprimento/5);    // hidrog\u00eanio
      fill(0xff91D6F7); // AZUL
      ellipse(0, 0, 1.3f*(comprimento/5), 1.3f*(comprimento/5)); // desenhamos o \u00e1tomo de carbono
      popMatrix();
    }
    
    pushMatrix();
    translate(7*comprimento/2, 0); // origem: \u00e1tomo de nitrog\u00eanio \u00e0 direita
    stroke(0);
    line(0, 0, - comprimento/4, 0);
    pushMatrix();
    rotate( - PI/3 - u*PI/6); // o \u00e2ngulo depende de 'u'
    line(0, 0, comprimento/2, 0);
    noStroke();
    fill(122); // CINZA
    ellipse(comprimento/2, 0, comprimento/5, comprimento/5); // desenhamos um dos \u00e1tomos de hidrog\u00eanio ligados
    popMatrix();
    pushMatrix();
    rotate(PI/3 - u*PI/3); // o \u00e2ngulo depende de 'u'
    stroke(0);
    line(0, 0, comprimento/4, 0);
    pushMatrix();
    
    // dependendo do valor assumido por 'u', mostramos (ou n\u00e3o) um dos \u00e1tomos de hidrog\u00eanio ligado ao nitrog\u00eanio \u00e0 direita
    if(u != 1){
      translate(comprimento/2, 0); // origem: segundo \u00e1tomo de hidrog\u00eanio ligado ao nitrog\u00eanio \u00e0 direita
      line(0, 0, - comprimento/4, 0);
      noStroke();
      fill(122); // CINZA
      ellipse(0, 0, comprimento/5, comprimento/5); // desenhamos o hidrog\u00eanio
    } 
   
    popMatrix();
    noStroke();
    fill(0xff08FF85); // VERDE
    ellipse(0, 0, 1.3f*comprimento/5, 1.3f*comprimento/5); // desenhamos o nitrog\u00eanio da direita
    popMatrix();    
    
    popMatrix();
    popMatrix();
  }
  
  // fun\u00e7\u00e3o que 'abre' as liga\u00e7\u00f5es do nitrog\u00eanio \u00e0 esquerda ao mudar o valor de 'w'
  public void abre(float v){
    if(w < 1)
      w += v;
    else
      w = 1;
  }
  
  // fun\u00e7\u00e3o que faz a mul\u00e9cula se mover no plano
  public void anda(float vx, float vy){
    xpos += vx;
    ypos += vy;
  }
  
  // define uma nova posi\u00e7\u00e3o
  public void setPosition(float x, float y){
    xpos = x;
    ypos = y;
  }
}
class Polimero{
  
  float xpos, ypos; // coordenadas de posi\u00e7\u00e3o
  
  float t; //tempo de anima\u00e7\u00e3o (para movimentar as mol\u00e9culas de \u00e1gua
  float[] vx; // guarda os valores de velocidade horizontal das mol\u00e9culas de \u00e1gua
  float[] vy; // o mesmo para a dire\u00e7\u00e3o vertical
  float[] w; //guarda as velocidades angulares das mol\u00e9culas de \u00e1gua
  
    
  // Cada objeto dessa classe possui um vetor de objetos da classe Adipico e um de objetos da classe Diamina,
  // para formar a cadeia polim\u00e9rica
  Adipico[] a = new Adipico[10];
  Diamina[] d = new Diamina[10];
  Agua[] h = new Agua [20];

  
 // a = new Adipico[10];
 // d = new Diamina[10];
   
  // CONSTRUTORA
  Polimero(float x, float y){
    xpos = x;
    ypos = y;
    
    t = 0;
    vx = new float[20];
    vy = new float[20];
    w = new float[20];
      
    for(int i = 0; i < 10; i++){
      a[i] = new Adipico(xpos + i*7*comprimento, ypos); // as mol\u00e9culas de \u00e1c. ad\u00edpico s\u00e3o posicionadas de acordo com seu \u00edndice no vetor
      a[i].w = a[i].u = 1; // 'w' e 'u' assumem valor 1 pois todas as mol\u00e9culas est\u00e3o ligadas (e, portanto, aparecem 'abertas')
    
      // o mesmo fazemos para as mol\u00e9culas de diamina
      d[i] = new Diamina(xpos + comprimento/2 + i*7*comprimento, ypos);
      d[i].w = d[i].u = 1;
    }
    
    for(int i = 0; i < 20; i++){    
      
      // para que as mol\u00e9ulas de \u00e1gua n\u00e3o cruzem o pol\u00edmero, definimos um racional r que guarda 1 ou -1
      // dando \u00e0s mol\u00e9culas velocidades que as afastem da cadeia polim\u00e9rica
      float r = random(-1, 1);
      r = (abs(r))/r;
      
        // as mol\u00e9culas de \u00e1gua s\u00e3o posicionadas proximas \u00e0s liga\u00e7\u00f5es pept\u00eddicas
      if(i%2 == 0){
        h[i] = new Agua(a[i/2].xpos + comprimento/2, ypos + (1/2 + abs(sin(i)))*r*comprimento);
      }
      else
        h[i] = new Agua(a[i/2].xpos + comprimento/2 + 4*comprimento, ypos + (1/2 + abs(sin(i)))*r*comprimento);
        
      h[i].angle = i*PI/7; // damos um \u00e2ngulo de rota\u00e7\u00e3o inicial espec\u00edfico para cada mol\u00e9cula de \u00e1gua
      
      //cada mol\u00e9cula possui uma velocidade espec\u00edfica de transla\u00e7\u00e3o e rota\u00e7\u00e3o      
      vx[i] = random(-.2f,.2f);
      vy[i] = r*random(.2f, .4f);
      w[i] = random(-PI/160, PI/160);
    }
  }

 
  
  // fun\u00e7\u00e3o que atualiza a posi\u00e7\u00e3o e o tamanho das mol\u00e9culas internas \u00e0 cadeia de acordo com o valor atual
  // de 'comprimento'
   public void update(){
     
     for(int i = 0; i < 10; i++){
       
    /*a[i] = new Adipico(xpos + i*7*comprimento, ypos); // as mol\u00e9culas de \u00e1c. ad\u00edpico s\u00e3o posicionadas de acordo com seu \u00edndice no vetor
    a[i].w = a[i].u = 1; // 'w' e 'u' assumem valor 1 pois todas as mol\u00e9culas est\u00e3o ligadas (e, portanto, aparecem 'abertas')
    
    // o mesmo fazemos para as mol\u00e9culas de diamina
    d[i] = new Diamina(xpos + comprimento/2 + i*7*comprimento, ypos);
    d[i].w = d[i].u = 1;
    
    float r = random(-1, 1);
    r = (abs(r))/r;
    h[i] = new Agua(a[i].xpos + comprimento/2, ypos + random(1, 2)*r*comprimento);
    h[i].angle = i*PI/7;
    */
    
    //ao inv\u00e9s de reiniciarmos os vetores, apenas reposicionamos os objetos , adaptando-os \u00e0 nova escala
    // para apresentar um pol\u00edmero j\u00e1 formado
    a[i].setPosition(xpos + i*7*comprimento, ypos);
    a[i].w = a[i].u = 1;
    
    d[i].setPosition(xpos + comprimento/2 + i*7*comprimento, ypos);
    d[i].w = a[i].u = 1;
    }
    
    for(int i = 0; i < 20; i++){
      
      // novamente utilizamos um racional r para dar o sentido correto \u00e0 mol\u00e9cula de \u00e1gua, 
      // impedindo que esta cruze a cadeia polim\u00e9rica
      float r =  -( ypos - h[i].ypos);
      r = abs(r)/r;
      
      // posicionamos as mol\u00e9culas em sua nova posi\u00e7\u00e3o ap\u00f3s a rota\u00e7\u00e3o e a transla\u00e7\u00e3o  
      // considerando a nova escala da anima\u00e7\u00e3o (baseando-nos no 'tempo de vida' do
      // objeto Polimero)
      if(i%2 == 0)
        h[i].setPosition(a[i/2].xpos + comprimento/2 + t*vx[i]*comprimento/60, ypos + (1+ abs(sin(i)))*r*comprimento + t*vy[i]*comprimento/60);
      else
        h[i].setPosition(a[i/2].xpos + comprimento/2 + 4*comprimento + t*vx[i]*comprimento/60, ypos + (1+ abs(sin(i)))*r*comprimento + t*vy[i]*comprimento/60);
      h[i].gira(w[i]);
    }
    
    // andamos com o tempo
    t++;
   }
  
  // fun\u00e7\u00e3o que mostra a cadeia polim\u00e9rica
  public void display(){
    // utilizamos a fun\u00e7\u00e3o 'display' das outras classes
    for(int i = 0; i < 10; i++){
      a[i].display();
      d[i].display();
    }
    
    //somente desenhamos as mol\u00e9culas de \u00e1gua que estiverem no campo de anima\u00e7\u00e3o, 
    //ao alcance do ret\u00e2ngulo de atualiza\u00e7\u00e3o
    for(int i = 0; i < 20; i++){
      if(abs(h[i].ypos - ypos) < 12*height/60 )
        h[i].display();
    }
    
  }
  
}
 
    
  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "Polimerizacao_Etapas" });
  }
}
