class Polimero{
  
  float xpos, ypos; // coordenadas de posição
  
  float t; //tempo de animação (para movimentar as moléculas de água
  float[] vx; // guarda os valores de velocidade horizontal das moléculas de água
  float[] vy; // o mesmo para a direção vertical
  float[] w; //guarda as velocidades angulares das moléculas de água
  
    
  // Cada objeto dessa classe possui um vetor de objetos da classe Adipico e um de objetos da classe Diamina,
  // para formar a cadeia polimérica
  Adipico[] a = new Adipico[10];
  Diamina[] d = new Diamina[10];
  Agua[] h = new Agua [20];

  
 // a = new Adipico[10];
 // d = new Diamina[10];
   
  // CONSTRUTORA
  Polimero(float x, float y){
    xpos = x;
    ypos = y;
    
    t = 0;
    vx = new float[20];
    vy = new float[20];
    w = new float[20];
      
    for(int i = 0; i < 10; i++){
      a[i] = new Adipico(xpos + i*7*comprimento, ypos); // as moléculas de ác. adípico são posicionadas de acordo com seu índice no vetor
      a[i].w = a[i].u = 1; // 'w' e 'u' assumem valor 1 pois todas as moléculas estão ligadas (e, portanto, aparecem 'abertas')
    
      // o mesmo fazemos para as moléculas de diamina
      d[i] = new Diamina(xpos + comprimento/2 + i*7*comprimento, ypos);
      d[i].w = d[i].u = 1;
    }
    
    for(int i = 0; i < 20; i++){    
      
      // para que as moléulas de água não cruzem o polímero, definimos um racional r que guarda 1 ou -1
      // dando às moléculas velocidades que as afastem da cadeia polimérica
      float r = random(-1, 1);
      r = (abs(r))/r;
      
        // as moléculas de água são posicionadas proximas às ligações peptídicas
      if(i%2 == 0){
        h[i] = new Agua(a[i/2].xpos + comprimento/2, ypos + (1/2 + abs(sin(i)))*r*comprimento);
      }
      else
        h[i] = new Agua(a[i/2].xpos + comprimento/2 + 4*comprimento, ypos + (1/2 + abs(sin(i)))*r*comprimento);
        
      h[i].angle = i*PI/7; // damos um ângulo de rotação inicial específico para cada molécula de água
      
      //cada molécula possui uma velocidade específica de translação e rotação      
      vx[i] = random(-.2,.2);
      vy[i] = r*random(.2, .4);
      w[i] = random(-PI/160, PI/160);
    }
  }

 
  
  // função que atualiza a posição e o tamanho das moléculas internas à cadeia de acordo com o valor atual
  // de 'comprimento'
   void update(){
     
     for(int i = 0; i < 10; i++){
       
    /*a[i] = new Adipico(xpos + i*7*comprimento, ypos); // as moléculas de ác. adípico são posicionadas de acordo com seu índice no vetor
    a[i].w = a[i].u = 1; // 'w' e 'u' assumem valor 1 pois todas as moléculas estão ligadas (e, portanto, aparecem 'abertas')
    
    // o mesmo fazemos para as moléculas de diamina
    d[i] = new Diamina(xpos + comprimento/2 + i*7*comprimento, ypos);
    d[i].w = d[i].u = 1;
    
    float r = random(-1, 1);
    r = (abs(r))/r;
    h[i] = new Agua(a[i].xpos + comprimento/2, ypos + random(1, 2)*r*comprimento);
    h[i].angle = i*PI/7;
    */
    
    //ao invés de reiniciarmos os vetores, apenas reposicionamos os objetos , adaptando-os à nova escala
    // para apresentar um polímero já formado
    a[i].setPosition(xpos + i*7*comprimento, ypos);
    a[i].w = a[i].u = 1;
    
    d[i].setPosition(xpos + comprimento/2 + i*7*comprimento, ypos);
    d[i].w = a[i].u = 1;
    }
    
    for(int i = 0; i < 20; i++){
      
      // novamente utilizamos um racional r para dar o sentido correto à molécula de água, 
      // impedindo que esta cruze a cadeia polimérica
      float r =  -( ypos - h[i].ypos);
      r = abs(r)/r;
      
      // posicionamos as moléculas em sua nova posição após a rotação e a translação  
      // considerando a nova escala da animação (baseando-nos no 'tempo de vida' do
      // objeto Polimero)
      if(i%2 == 0)
        h[i].setPosition(a[i/2].xpos + comprimento/2 + t*vx[i]*comprimento/60, ypos + (1+ abs(sin(i)))*r*comprimento + t*vy[i]*comprimento/60);
      else
        h[i].setPosition(a[i/2].xpos + comprimento/2 + 4*comprimento + t*vx[i]*comprimento/60, ypos + (1+ abs(sin(i)))*r*comprimento + t*vy[i]*comprimento/60);
      h[i].gira(w[i]);
    }
    
    // andamos com o tempo
    t++;
   }
  
  // função que mostra a cadeia polimérica
  void display(){
    // utilizamos a função 'display' das outras classes
    for(int i = 0; i < 10; i++){
      a[i].display();
      d[i].display();
    }
    
    //somente desenhamos as moléculas de água que estiverem no campo de animação, 
    //ao alcance do retângulo de atualização
    for(int i = 0; i < 20; i++){
      if(abs(h[i].ypos - ypos) < 12*height/60 )
        h[i].display();
    }
    
  }
  
}
 
    
